unit grutil;
interface
uses graph,crt;
var i,j:integer;
type pal=array [0..15] of byte;
{            0  1  2  3  4  5  6  7  8  9  10  11  12  13  14  15}
{-----------------------------------------------------------------}
const r:pal=(0, 0, 0, 0, 32,32,32,32,16,0, 0,  0,  63, 63, 63, 63);
      g:pal=(0, 0, 32,32,0, 0, 16,32,16,32,63, 63, 0,  0,  63, 63);
      b:pal=(0, 32,0, 32,0, 32,32,32,16,63,0,  63, 0,  63, 0,  63);
    num:pal=(0, 1, 2, 3, 4, 5, 20, 7,56,57,58, 59, 60, 61, 62, 63);

procedure fadein;
procedure fadeout;
procedure qfadein;
procedure qfadeout;
procedure cerceve(x,y,cx,cy:word;tip,kare:byte);
procedure color(n:byte);
procedure setpalet(d,dr,dg,db:byte);
procedure setdef;
procedure kur;
procedure Kapat;

implementation

procedure kur;
var gs,gm:integer;
begin
detectgraph(gs,gm);
initgraph(gs,gm,'c:\tp\bgi\');
setdef;
end;

procedure cerceve(x,y,cx,cy:word;tip,kare:byte);
begin
if tip=0 then color(15) else color(0);
line(x,y,cx,y);
line(x,y,x,cy);
if kare=2 then begin
line(x+1,y+1,cx-1,y+1);
line(x+1,y+1,x+1,cy-1);
end;
if tip=0 then color(0) else color(15);
line(cx,y,cx,cy);
line(cx,cy,x,cy);
if kare=2 then
begin
line(cx-1,y+1,cx-1,cy-1);
line(cx-1,cy-1,x+1,cy-1);
end;
end;



procedure color;begin setcolor(num[n]);end;

procedure fadein;
var cr,cg,cb:byte;
begin
for i:=0 to 15 do setrgbpalette(num[i],0,0,0);
delay(400);
for i:=0 to 32 do begin
for j :=0 to 15 do begin case r[j] of
                                    63:cr:=abs(i*2-1);
                                    32:cr:=i;
                                    16:cr:=i div 2;
                                    0:cr:=0;
                        end;
                        case g[j] of
                                    63:cg:=abs(i*2-1);
                                    32:cg:=i;
                                    16:cg:=i div 2;
                                    0:cg:=0;
                        end;
                        case b[j] of
                                    63:cb:=abs(i*2-1);
                                    32:cb:=i;
                                    16:cb:=i div 2;
                                    0:cb:=0;
                        end;
                         setrgbpalette(num[j],cr,cg,cb);
                   end;
delay(1);
end;
end;

procedure qfadein;
var cr,cg,cb:byte;
begin
for i:=0 to 15 do setrgbpalette(num[i],0,0,0);
delay(400);
for i:=0 to 16 do begin
for j :=0 to 15 do begin case r[j] of
                                    63:cr:=abs(i*4-1);
                                    32:cr:=i*2;
                                    16:cr:=i;
                                    0:cr:=0;
                        end;
                        case g[j] of
                                    63:cg:=abs(i*4-1);
                                    32:cg:=i*2;
                                    16:cg:=i;
                                    0:cg:=0;
                        end;
                        case b[j] of
                                    63:cb:=abs(i*4-1);
                                    32:cb:=i*2;
                                    16:cb:=i;
                                    0:cb:=0;
                        end;
                         setrgbpalette(num[j],cr,cg,cb);
                   end;
delay(1);
end;
end;


procedure setdef; begin for i:=0 to 15 do setrgbpalette(num[i],r[i],g[i],b[i]); end;
procedure kapat; begin for i:=0 to 15 do setrgbpalette(num[i],0,0,0); end;
procedure setpalet; begin setrgbpalette(num[d],dr,dg,db);end;

procedure fadeout;
var cr,cg,cb:byte;
begin
for i:=32 downto 0 do begin
for j :=0 to 15 do begin case r[j] of
                                    63:cr:=abs(i*2-1);
                                    32:cr:=i;
                                    16:cr:=i div 2;
                                    0:cr:=0;
                        end;
                        case g[j] of
                                    63:cg:=abs(i*2-1);
                                    32:cg:=i;
                                    16:cg:=i div 2;
                                    0:cg:=0;
                        end;
                        case b[j] of
                                    63:cb:=abs(i*2-1);
                                    32:cb:=i;
                                    16:cb:=i div 2;
                                    0:cb:=0;
                        end;
                         setrgbpalette(num[j],cr,cg,cb);
                   end;
end;
delay(300);
end;

procedure qfadeout;
var cr,cg,cb:byte;
begin
for i:=16 downto 0 do begin
for j :=0 to 15 do begin case r[j] of
                                    63:cr:=abs(i*4-1);
                                    32:cr:=i*2;
                                    16:cr:=i;
                                    0:cr:=0;
                        end;
                        case g[j] of
                                    63:cg:=abs(i*4-1);
                                    32:cg:=i*2;
                                    16:cg:=i;
                                    0:cg:=0;
                        end;
                        case b[j] of
                                    63:cb:=abs(i*4-1);
                                    32:cb:=i*2;
                                    16:cb:=i;
                                    0:cb:=0;
                        end;
                         setrgbpalette(num[j],cr,cg,cb);
                   end;
end;
delay(300);
end;

end.